fake_csv/urls.py
from django.contrib import admin
from django.urls import path, include
from . import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home_view, name='home'),
    path('logout', views.logout_view, name='logout'),
    path('schema/', include('schema.urls')),
]

schema/urls.py
from django.urls import path
from . import views

app_name = 'schema'
urlpatterns = [
    path('', views.list_view, name='list_view'),
    path('create', views.create_view, name='create_view'),
    path('<int:schema_id>/', views.detail_view, name='detail_view'),
    path('update/<int:schema_id>/', views.update_view, name='update_view'),
    path('delete', views.delete_view),
    path('post-schema-types', views.post_schema_types_view, name='post_schema_types_view'),
    # path('download/<int:schema_id>/<int:schema_item_id>/<str:file_name>/', views.download_view, name='download_view'),

    path('post_create_csv_file', views.post_create_csv_file, name='post_create_csv_file'),
    path('post_csv_file_task_status/<uuid:task_id>/', views.post_csv_file_task_status,
         name='post_csv_file_task_status'),
]

schema/models.py
import os

from django.db import models
from django.utils import timezone

NAME = 'name'
JOB = 'job'
EMAIL = 'email'
DOMAIN_NAME = 'domain_name'
PHONE_NUMBER = 'phone_number'
COMPANY = 'company'
PARAGRAPH = 'paragraph'
PYINT = 'pyint'
ADDRESS = 'address'

SCHEMA_TYPES = [
    (NAME, 'Name'),
    (JOB, 'Job'),
    (EMAIL, 'Email'),
    (DOMAIN_NAME, 'Domain name'),
    (PHONE_NUMBER, 'Phone number'),
    (COMPANY, 'Company'),
    (PARAGRAPH, 'paragraph'),
    (PYINT, 'Int'),
    (ADDRESS, 'Address'),
]

COMMA = ','
SEMICOLON = ';'
TAB = '\t'
COLUMN_SEPARATORS = [
    (COMMA, 'Comma (,)'),
    (SEMICOLON, 'Semicolon (;)'),
    (TAB, 'Tab ( )'),
]

DOUBLE_QUOTE = '"'
STRING_CHARACTERS = [
    (DOUBLE_QUOTE, 'Double-quote (")'),
]

FAILURE = 'FAILURE'
PENDING = 'PENDING'
SUCCESS = 'SUCCESS'
STATUSES = [
    (FAILURE, 'Failure'),
    (PENDING, 'Processing'),
    (SUCCESS, 'Ready')
]

STATUSES_DESC = {
    FAILURE: {'name': 'Failure', 'css_class': 'is-danger'},
    PENDING: {'name': 'Processing', 'css_class': 'is-info'},
    SUCCESS: {'name': 'Ready', 'css_class': 'is-success'},
}


# Create your models here.
class SchemaType(models.Model):
    name = models.CharField(max_length=128, blank=False)
    type = models.CharField(max_length=16, choices=SCHEMA_TYPES, blank=False, verbose_name='Name of Faker\'s function')

    def __str__(self):
        return self.name


class Schema(models.Model):
    name = models.CharField(max_length=128, blank=False)
    column_separator = models.CharField(max_length=1, default=COMMA, choices=COLUMN_SEPARATORS)
    string_character = models.CharField(max_length=1, default=DOUBLE_QUOTE, choices=STRING_CHARACTERS)
    created = models.DateTimeField(default=timezone.now)
    updated = models.DateTimeField(default=timezone.now)

    class Meta:
        ordering = ['-created']

    def __str__(self):
        return self.name

    def save(self, *args, **kwargs):
        self.updated = timezone.now()
        super().save(*args, **kwargs)

    def columns_types(self):
        return self.columns.select_related('schema_type').all()


class SchemaColumn(models.Model):
    name = models.CharField(max_length=128, blank=False)
    order = models.PositiveSmallIntegerField(default=0)
    min = models.PositiveSmallIntegerField(default=0, verbose_name='For pyint schema type range')
    max = models.PositiveSmallIntegerField(default=0, verbose_name='For pyint, paragraph schema types range')
    schema = models.ForeignKey(Schema, related_name='columns', related_query_name='column', on_delete=models.CASCADE)
    schema_type = models.ForeignKey(SchemaType, related_name='columns', related_query_name='column', null=True,
                                    on_delete=models.SET_NULL)

    class Meta:
        ordering = ['order']

    def __str__(self):
        return '{}: {}'.format(self.pk, self.schema_type.name)


class SchemaItem(models.Model):
    created = models.DateTimeField(default=timezone.now)
    status = models.CharField(max_length=16, choices=STATUSES, verbose_name='Celery status')
    file = models.FileField(upload_to='schema/media', blank=True)
    task_id = models.CharField(max_length=36, db_index=True, verbose_name='Celery task.id')
    schema = models.ForeignKey(Schema, related_name='items', related_query_name='item', on_delete=models.CASCADE)

    class Meta:
        ordering = ['pk']

    def __str__(self):
        return '{} ({})'.format(self.schema.name, self.status)

    @property
    def filename(self):
        return self.file.name

    @property
    def status_name(self):
        return STATUSES_DESC[self.status]['name']

    @property
    def status_css_class(self):
        return STATUSES_DESC[self.status]['css_class']

schema/views.py
import logging
import os
from pathlib import Path

from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect, JsonResponse, HttpResponse, Http404
from django.shortcuts import render, get_object_or_404, redirect

from celery.result import AsyncResult
from django.utils import timezone

from schema.models import Schema, SchemaColumn, SchemaType, SchemaItem
from schema.models import COLUMN_SEPARATORS, STRING_CHARACTERS, PENDING, SUCCESS, STATUSES_DESC
from schema.tasks import create_csv_file

logger = logging.getLogger(__name__)


# Create your views here.
@login_required
def list_view(request):
    """
    Displays all schemas.
    """
    return render(request, 'list_view.html', {
        'schemas': Schema.objects.all(),
    })


@login_required
def create_view(request):
    """
    Creates a schema.
    """
    if request.method == 'POST':
        result = _delete_schema_column(request)
        if result is not None:
            return result
        schema = _update_or_create_schema(request)
        return _update_or_create_schema_columns(request, schema)

    return render(request, 'create_view.html', {
        'schema_types': SchemaType.objects.all(),
        'column_separator': [i[0] for i in COLUMN_SEPARATORS],
        'string_character': [i[0] for i in STRING_CHARACTERS],
    })


@login_required
def detail_view(request, schema_id):
    """
    Displays schema's data by schema_id.
    """
    schema = get_object_or_404(Schema, pk=schema_id)
    return render(request, 'detail_view.html', {
        'schema': schema,
        'schema_items': SchemaItem.objects.filter(schema=schema)
    })


@login_required
def update_view(request, schema_id):
    """
    Updates schema's data by schema_id.
    """
    schema = get_object_or_404(Schema, pk=schema_id)
    if request.method == 'POST':
        result = _delete_schema_column(request)
        if result is not None:
            return result
        _update_or_create_schema(request, schema)
        return _update_or_create_schema_columns(request, schema)

    return render(request, 'update_view.html', {
        'schema': schema,
        'schema_columns': schema.columns_types(),
        'schema_types': SchemaType.objects.all(),
        'column_separator': [i[0] for i in COLUMN_SEPARATORS],
        'string_character': [i[0] for i in STRING_CHARACTERS],
    })


@login_required
def delete_view(request):
    """
    Deletes schema by schema_id.
    """
    try:
        schema_id = [s for s in request.POST if 'schema_id' in str(s)][0].split('-')[1]
    except IndexError:
        return HttpResponseRedirect(request.META.get('HTTP_REFERER'))

    schema = get_object_or_404(Schema, pk=schema_id)
    schema.delete()
    return redirect('schema:list_view')


"""
Downloads local file
@login_required
def download_view(request, schema_id, schema_item_id, file_name):
    schema_item = get_object_or_404(SchemaItem, pk=schema_item_id)
    if Path(schema_item.file.path).exists():
        with open(schema_item.file.path, 'rb') as f:
            response = HttpResponse(f.read(), content_type="text/csv")
            response['Content-Disposition'] = 'inline; filename=' + Path(schema_item.file.path).name
            return response
    raise Http404
"""


def post_schema_types_view(request):
    """
    Gets all possible schema types.
    """
    data = list(SchemaType.objects.all().values('id', 'name', 'type'))
    return JsonResponse(data, safe=False, status=200)


def post_create_csv_file(request):
    """
    Creates csv file with Celery task.
    """
    if request.method == 'POST':
        schema_id = int(request.POST['schema_id'])
        count = int(request.POST['count'])

        schema = Schema.objects.get(pk=schema_id)
        schema_item = SchemaItem.objects.create(status=PENDING, schema=schema)
        schema_item.save()
        schema_item_id = schema_item.id

        task = create_csv_file.delay(schema_id, schema_item_id, count)
        schema_item.task_id = task.id
        schema_item.save()
        return JsonResponse({
            'task_id': task.id,
            'created': schema_item.created.strftime('%d:%m:%Y %H:%M'),
            'schema_id': schema_id,
            'schema_item_id': schema_item.id,
            'status': schema_item.status,
            'status_name': STATUSES_DESC[schema_item.status]['name'],
            'status_class': STATUSES_DESC[schema_item.status]['css_class']
        }, status=202)


def post_csv_file_task_status(request, task_id):
    """
    Gets Celery task status, updates status on page.
    """
    if request.method == 'POST':
        task_id = str(task_id)
        task = AsyncResult(task_id)
        schema_item = SchemaItem.objects.get(task_id=task_id)
        if schema_item.file.name:
            logger.debug('File (4): {} {}'.format(timezone.now(), str(Path(schema_item.file.path).exists())))
        else:
            logger.debug('File (3): {} False'.format(timezone.now()))
        response = {
            'task_id': task_id,
            'status': task.status,
            'status_name': STATUSES_DESC[task.status]['name'],
            'status_class': STATUSES_DESC[task.status]['css_class'],
            'info': task.info,
        }
        if task.status == SUCCESS:
            schema_item.status = SUCCESS
            schema_item.save()
            kwargs = {
                'schema_id': schema_item.schema_id,
                'schema_item_id': schema_item.id,
                'file_name': schema_item.filename
            }
            response.update(kwargs)
        return JsonResponse(response, status=200)


def _delete_schema_column(request):
    matching = [s for s in request.POST if 'delete_schema_column' in str(s)]
    if matching:
        schema_column_id = matching[0].split('-')[1]
        if 'new_' in schema_column_id:
            return HttpResponseRedirect(request.path_info)
        schema_column = get_object_or_404(SchemaColumn, pk=schema_column_id)
        schema_column.delete()
        return HttpResponseRedirect(request.path_info)
    return None


def _update_or_create_schema(request, schema=None):
    kwargs = {s.split('-')[1]: request.POST['schema_form-' + s.split('-')[1]] for s in
              [s for s in request.POST if 'schema_form' in str(s)]}
    if schema is None:
        return Schema.objects.create(**kwargs)
    else:
        return Schema.objects.filter(pk=schema.pk).update(**kwargs)


def _update_or_create_schema_columns(request, schema):
    schema_columns = {}
    for s in [s for s in request.POST if str(s).startswith('schema_column')]:
        _, schema_column_id, field = s.split('-')
        schema_columns.setdefault(schema_column_id, {})
        schema_columns[schema_column_id].setdefault(field,
                                                    request.POST[
                                                        'schema_column-{}-{}'.format(schema_column_id, field)])
    for pk, kwargs in schema_columns.items():
        kwargs.update({'schema_id': schema.id})
        if 'new_' in pk:
            kwargs.pop('id')
            SchemaColumn.objects.create(**kwargs)
        else:
            schema_column = SchemaColumn.objects.filter(pk=pk)
            schema_column.update(**kwargs)

    return redirect('schema:list_view')

schema/templates/create_view.html
{% extends "base.html" %}
{% block title %}Schema list{% endblock %}
{% block content %}
    <nav class="breadcrumb" aria-label="breadcrumbs">
        <ul>
            <li><a href="{% url 'home' %}">Home</a></li>
            <li><a href="{% url 'schema:list_view' %}">Schema list</a></li>
            <li class="is-active">Create schema</li>
        </ul>
    </nav>

    <form method="post">
        {% csrf_token %}
        <div class="level-right">
            <button class="button is-primary level-item" type="submit">Create</button>
        </div>
        <label class="label">Name</label>
        <div class="field">
            <div class="control">
                <input class="input" type="text" name="schema_form-name">
            </div>
        </div>
        <label class="label">Column separator</label>
        <div class="field">
            <div class="control">
                <div class="select">
                    <select name="schema_form-column_separator">
                        {% for item in column_separator %}
                            <option value="{{ item }}">{{ item }}</option>
                        {% endfor %}
                    </select>
                </div>
            </div>
        </div>
        <label class="label">String character</label>
        <div class="field">
            <div class="control">
                <div class="select">
                    <select name="schema_form-string_character">
                        {% for item in string_character %}
                            <option value="{{ item }}">{{ item }}</option>
                        {% endfor %}
                    </select>
                </div>
            </div>
        </div>
        <br>
        <div class="columns">
            <div class="column">
                <label class="label">Column name</label>
            </div>
            <div class="column">
                <label class="label">Type</label>
            </div>
            <div class="column">
                <label class="label">From</label>
            </div>
            <div class="column">
                <label class="label">To</label>
            </div>
            <div class="column">
                <label class="label">Order</label>
            </div>
        </div>
        <div class="columns-container">
        </div>
        <button class="button is-primary add-column">Add column</button>
    </form>

{% endblock %}

schema/templates/detail_view.html
{% extends "base.html" %}
{% block title %}Schema list{% endblock %}
{% block content %}
    <nav class="breadcrumb" aria-label="breadcrumbs">
        <ul>
            <li><a href="{% url 'home' %}">Home</a></li>
            <li><a href="{% url 'schema:list_view' %}">Schema list</a></li>
            <li class="is-active"><a
                    href="{% url 'schema:detail_view' schema_id=schema.pk %}">Schema #{{ schema.pk }}</a></li>
        </ul>
    </nav>

    <form method="post">
        {% csrf_token %}
        <div class="level-right">
            <div class="level-item">
                <input name="schema_id" type="hidden" value="{{ schema.pk }}">
                <input class="input" name="count" type="number" value="500">
            </div>
            <button class="button level-item is-primary generate-data" type="submit">Generate data</button>
        </div>
        <table class="table">
            <thead>
            <tr>
                <th>#</th>
                <th>Created</th>
                <th class="status">Status</th>
                <th>Actions</th>
            </tr>
            </thead>
            <tbody>
            {% for item in schema_items %}
                <tr id="{{ item.task_id }}">
                    <td>{{ item.pk }}</td>
                    <td>{{ item.created|date:'d.m.Y H:i' }}</td>
                    <td class="status"><span class="tag {{ item.status_css_class }}">{{ item.status_name }}</span></td>
                    <td>
                        {% if item.status == 'SUCCESS' %}
                            {#<a href="{% url 'schema:download_view' schema_id=schema.pk schema_item_id=item.pk file_name=item.filename %}">Download</a>#}
                            <a href="{{ item.filename }}">Download</a>
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </form>
{% endblock %}

schema/templates/list_view.html
{% extends "base.html" %}
{% block title %}Schema list{% endblock %}
{% block content %}
    <nav class="breadcrumb" aria-label="breadcrumbs">
        <ul>
            <li><a href="{% url 'home' %}">Home</a></li>
            <li class="is-active"><a href="{% url 'schema:list_view' %}">Schema list</a></li>
        </ul>
    </nav>

    <form action="delete" method="post">
        {% csrf_token %}
        <div class="level-right">
            <a class="button level-item is-primary" href="{% url 'schema:create_view' %}">New schema</a>
        </div>
        <table class="table">
            <thead>
            <tr>
                <th>#</th>
                <th>Title</th>
                <th>Modified</th>
                <th colspan="2">Actions</th>
            </tr>
            </thead>
            <tbody>
            {% for schema in schemas %}
                <tr>
                    <td>{{ schema.pk }}</td>
                    <td><a href="{% url 'schema:detail_view' schema_id=schema.pk %}">{{ schema.name }}</a></td>
                    <td>{{ schema.updated|date:'d.m.Y H:i' }}</td>
                    <td><a href="{% url 'schema:update_view' schema_id=schema.pk %}">Edit</a></td>
                    <td>
                        <a onclick="return confirm('Are you sure you want to delete this item?');">
                            <button type="submit" name='schema_id-{{ schema.pk }}'>Delete</button>
                        </a>
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </form>
{% endblock %}

schema/templates/update_view.html
{% extends "base.html" %}
{% block title %}Schema list{% endblock %}
{% block content %}
    <nav class="breadcrumb" aria-label="breadcrumbs">
        <ul>
            <li><a href="{% url 'home' %}">Home</a></li>
            <li><a href="{% url 'schema:list_view' %}">Schema list</a></li>
            <li class="is-active">Update schema #{{ schema.pk }}</li>
        </ul>
    </nav>

    <form method="post">
        {% csrf_token %}
        <div class="level-right">
            <button class="button is-primary level-item" type="submit">Submit</button>
        </div>
        <label class="label">Name</label>
        <div class="field">
            <div class="control">
                <input class="input" type="text" name="schema_form-name" value="{{ schema.name }}">
            </div>
        </div>
        <label class="label">Column separator</label>
        <div class="field">
            <div class="control">
                <div class="select">
                    <select name="schema_form-column_separator">
                        {% for item in column_separator %}
                            <option {% if schema.column_separator == item %}
                                selected{% endif %} value="{{ item }}">{{ item }}</option>
                        {% endfor %}
                    </select>
                </div>
            </div>
        </div>
        <label class="label">String character</label>
        <div class="field">
            <div class="control">
                <div class="select">
                    <select name="schema_form-string_character">
                        {% for item in string_character %}
                            <option {% if schema.string_character == item %}
                                selected{% endif %} value="{{ item }}">{{ item }}</option>
                        {% endfor %}
                    </select>
                </div>
            </div>
        </div>
        <br>
        <div class="columns">
            <div class="column">
                <label class="label">Column name</label>
            </div>
            <div class="column">
                <label class="label">Type</label>
            </div>
            <div class="column">
                <label class="label">From</label>
            </div>
            <div class="column">
                <label class="label">To</label>
            </div>
            <div class="column">
                <label class="label">Order</label>
            </div>
        </div>
        <div class="columns-container">
            {% for item in schema_columns %}
                <div class="columns">
                    <input class="input" type="hidden" name="schema_column-{{ item.pk }}-id" value="{{ item.pk }}">
                    <div class="column field control">
                        <input class="input" type="text" name="schema_column-{{ item.pk }}-name"
                               value="{{ item.name }}">
                    </div>
                    <div class="column field control">
                        <div class="select">
                            <select name="schema_column-{{ item.pk }}-schema_type_id">
                                {% for type in schema_types %}
                                    <option {% if item.schema_type == type %}
                                        selected{% endif %} value="{{ type.pk }}"
                                        data-type="{{ type.type }}">{{ type.name }}</option>
                                {% endfor %}
                            </select>
                        </div>
                    </div>
                    {% with type=item.schema_type.type %}
                        {% if type == 'paragraph' or type == 'pyint' %}
                            <div class="column field control min" data-idx="{{ item.pk }}">
                                <input class="input" name="schema_column-{{ item.pk }}-min" type="number"
                                       value="{{ item.min }}">
                            </div>
                            <div class="column field control max" data-idx="{{ item.pk }}">
                                <input class="input" name="schema_column-{{ item.pk }}-max" type="number"
                                       value="{{ item.max }}">
                            </div>
                        {% else %}
                            <div class="column field control min" data-idx="{{ item.pk }}"></div>
                            <div class="column field control max" data-idx="{{ item.pk }}"></div>
                        {% endif %}
                    {% endwith %}
                    <div class="column">
                        <div class="columns">
                            <div class="column field control">
                                <input class="input" name="schema_column-{{ item.pk }}-order" type="number"
                                       value="{{ item.order }}">
                            </div>
                            <div class="column">
                                <a onclick="return confirm('Are you sure you want to delete this item?');">
                                    <button type="submit" name='delete_schema_column-{{ item.pk }}'>Delete</button>
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>
        <button class="button is-primary add-column">Add column</button>
    </form>

{% endblock %}